﻿Public Class fmMain
    Private Delegate Sub DIRQCallBack()
    Private pIRQCallBack As New DIRQCallBack(AddressOf IRQCallBack)

    Private Delegate Sub DSlaveCallBack(ByVal pi2cdata As UInteger, ByVal wSize As UShort)
    Private pSlaveCallBack As New DSlaveCallBack(AddressOf SlaveCallBack)

    Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As UInteger, ByVal Source As UInteger, ByVal Length As Integer)

    Private Declare Function geterrorstring Lib "LANIICMS.dll" (ByVal dwerr As UInteger) As String
    Private Declare Function initnetiic Lib "LANIICMS.dll" (ByVal pIRQCallBack As DIRQCallBack, ByVal pSlaveCallBack As DSlaveCallBack, ByVal IDString As String) As UInteger
    Private Declare Function connect Lib "LANIICMS.dll" (ByVal shost As String, ByVal iport As Integer, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function disconnect Lib "LANIICMS.dll" () As UInteger
    Private Declare Function connected Lib "LANIICMS.dll" () As UInteger
    Private Declare Function geti2cstatusstring Lib "LANIICMS.dll" (ByVal wstatus As UShort) As String

    Private Declare Function writei2c Lib "LANIICMS.dll" (ByVal ucSlvAddr As Byte, ByRef pi2cdata As Byte, ByVal wSize As UShort, ByRef wstatus As UShort, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function readi2c Lib "LANIICMS.dll" (ByVal ucSlvAddr As Byte, ByRef pi2cdata As Byte, ByRef wSize As UShort, ByRef wstatus As UShort, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function scani2c Lib "LANIICMS.dll" (ByRef pi2cdata As Byte, ByRef ucSize As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function setsclhilo Lib "LANIICMS.dll" (ByVal wSCLH As UShort, ByVal wSCLL As UShort, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function getsclhilo Lib "LANIICMS.dll" (ByRef wSCLH As UShort, ByRef wSCLL As UShort, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function setscl Lib "LANIICMS.dll" (ByVal dwfreq As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function getscl Lib "LANIICMS.dll" (ByRef dwfreq As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function resetirq Lib "LANIICMS.dll" (ByRef ucIRQMode As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function wrdi2c Lib "LANIICMS.dll" (ByVal ucSlvAddr As Byte, ByVal pwrdata As Byte, ByVal wwrSize As UShort, ByRef prddata As Byte, ByRef wrdsize As UShort, ByRef wstatus As UShort, ByVal dwTimeOut As UInteger) As UInteger

    Private Declare Function setmode Lib "LANIICMS.dll" (ByRef ucmode As Byte, ByRef ucSlvAddr As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function writei2cslavebuf Lib "LANIICMS.dll" (ByRef pi2cdata As Byte, ByVal wSize As UShort, ByVal ucEvent As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function seti2cslvaddr Lib "LANIICMS.dll" (ByRef ucSlvAddr As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function chkslvaddr Lib "LANIICMS.dll" (ByVal ucSlvAddr As Byte, ByRef ucConnected As Byte, ByVal dwTimeOut As UInteger) As UInteger

    Private Declare Function setgar Lib "LANIICMS.dll" (ByVal ucVal1 As Byte, ByVal ucVal2 As Byte, ByVal ucVal3 As Byte, ByVal ucVal4 As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function setsubr Lib "LANIICMS.dll" (ByVal ucVal1 As Byte, ByVal ucVal2 As Byte, ByVal ucVal3 As Byte, ByVal ucVal4 As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function setshar Lib "LANIICMS.dll" (ByVal ucVal1 As Byte, ByVal ucVal2 As Byte, ByVal ucVal3 As Byte, ByVal ucVal4 As Byte, ByVal ucVal5 As Byte, ByVal ucVal6 As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function setip Lib "LANIICMS.dll" (ByVal ucVal1 As Byte, ByVal ucVal2 As Byte, ByVal ucVal3 As Byte, ByVal ucVal4 As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function settcpport Lib "LANIICMS.dll" (ByVal wPort As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function setudpport Lib "LANIICMS.dll" (ByVal wPort As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function loadfactoryconfig Lib "LANIICMS.dll" (ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function reinit Lib "LANIICMS.dll" (ByVal dwTimeOut As UInteger) As UInteger

    Private Declare Function getnetconfig Lib "LANIICMS.dll" (ByRef pNetConfig As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memwr8bit Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByVal ucVal As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memwr16bit Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByVal wVal As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memwr32bit Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByVal dwVal As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memwrblock Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByRef pmemdata As Byte, ByVal wSize As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memrd8bit Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByRef ucVal As Byte, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memrd16bit Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByRef wVal As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memrd32bit Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByRef dwVal As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function memrdblock Lib "LANIICMS.dll" (ByVal wAddr As UInteger, ByRef pmemdata As Byte, ByRef wSize As UInteger, ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function savesettings Lib "LANIICMS.dll" (ByVal dwTimeOut As UInteger) As UInteger
    Private Declare Function resetsettings Lib "LANIICMS.dll" (ByVal dwTimeOut As UInteger) As UInteger

    Private Const RET_OK As UInteger = 0
    Private Const szIDString As String = "NETIICMS_VBDemo_MsgID"
    Dim wPrivateMsg As UInteger
    Dim sServer As String
    Dim iTCPPort As Integer

    Delegate Sub UpdateRTBoxHandler(ByVal strMessage As String)

    Public Sub UpdateTextMethod(ByVal strMessage As String)
        RTBox.AppendText(strMessage)
    End Sub

    Public Sub IRQCallBack()
        If Me.RTBox.InvokeRequired Then
            Dim d As New UpdateRTBoxHandler(AddressOf UpdateTextMethod)
            Me.Invoke(d, New Object() {"INTERRUPT" & vbNewLine})
        Else
            Me.RTBox.AppendText("INTERRUPT" & vbNewLine)
        End If
    End Sub

    Public Function GetByte(ByVal lptr As UInteger, ByVal Index As UInteger)
        Dim ptr As UInteger
        Dim Value As Byte

        ptr = lptr + Index
        CopyMemory(Value, ptr, 1)
        GetByte = Value
    End Function

    Public Sub SlaveCallBack(ByVal pi2cdata As UInteger, ByVal wSize As UShort)
        Dim i As UShort
        Dim stri As String
        stri = ""
        For i = 0 To wSize - 1
            stri = stri + "[0x" + Hex$(GetByte(pi2cdata, i)) + "] "
        Next

        If Me.RTBox.InvokeRequired Then
            Dim d As New UpdateRTBoxHandler(AddressOf UpdateTextMethod)
            Me.Invoke(d, New Object() {stri & vbNewLine})
        Else
            Me.RTBox.AppendText(stri & vbNewLine)
        End If
    End Sub


    Private Sub ConnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectToolStripMenuItem.Click
        If connected <> RET_OK Then
            If connect(sServer, iTCPPort, 1000) = RET_OK Then
                slb1.Text = "CONNECTED"
            Else
                slb1.Text = "UNABLE TO CONNECT"
            End If
        End If
    End Sub

    Private Sub DisconnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DisconnectToolStripMenuItem.Click
        If connected = RET_OK Then
            If disconnect = RET_OK Then
                slb1.Text = "DISCONNECTED"
            End If
        End If
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSetServerValues.Click
        If connected <> RET_OK Then
            sServer = edHost.Text
            iTCPPort = edPort.Text
        Else
            MessageBox.Show("CLIENT IS CONNECTED!")
        End If

    End Sub

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        sServer = "192.168.1.100"
        iTCPPort = 5000
        'AddressOf SlaveCallBack
        wPrivateMsg = initnetiic(pIRQCallBack, pSlaveCallBack, szIDString)
        If wPrivateMsg > 0 Then
            slb1.Text = "INITNETIIC OK"
        Else
            slb1.Text = "INITNETIIC FAILED"
        End If
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        Dim dwErr As UInteger
        Dim pBuf(24) As Byte
        Dim stri As String

        dwErr = getnetconfig(pBuf(0), 1000)
        If dwErr = RET_OK Then

            stri = Hex$(pBuf(0)) + "-" + Hex$(pBuf(1)) + "-" + Hex$(pBuf(2)) + "-" + Hex$(pBuf(3)) + "-" + Hex$(pBuf(4)) + "-" + Hex$(pBuf(5))
            lbShar.Text = stri

            stri = pBuf(11).ToString + "." + pBuf(10).ToString + "." + pBuf(9).ToString + "." + pBuf(8).ToString
            lbGar.Text = stri

            stri = pBuf(15).ToString + "." + pBuf(14).ToString + "." + pBuf(13).ToString + "." + pBuf(12).ToString
            lbSubr.Text = stri

            stri = pBuf(19).ToString + "." + pBuf(18).ToString + "." + pBuf(17).ToString + "." + pBuf(16).ToString
            lbIp.Text = stri

            stri = (pBuf(21) * 256 + pBuf(20)).ToString
            lbTCP.Text = stri

            stri = (pBuf(23) * 256 + pBuf(22)).ToString
            lbUDP.Text = stri
        Else : slb1.Text = "GET CONFIG: " + geterrorstring(dwErr)
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim tmp_addr As UInteger
        Dim tmp_byte As Byte
        Dim dwErr As UInteger

        tmp_addr = "&H" + edwraddr.Text
        tmp_byte = "&H" + edwrbyte.Text

        dwErr = memwr8bit(tmp_addr, tmp_byte, 1000)
        slb1.Text = "MEM WR BYTE: " + geterrorstring(dwErr)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim tmp_addr As UInteger
        Dim tmp_word As UInteger
        Dim dwErr As UInteger

        tmp_addr = "&H" + edwraddr.Text
        tmp_word = "&H" + edwrword.Text

        dwErr = memwr16bit(tmp_addr, tmp_word, 1000)
        slb1.Text = "MEM WR WORD: " + geterrorstring(dwErr)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim tmp_addr As UInteger
        Dim tmp_dword As UInteger
        Dim dwErr As UInteger

        tmp_addr = "&H" + edwraddr.Text
        tmp_dword = "&H" + edwrdword.Text

        dwErr = memwr32bit(tmp_addr, tmp_dword, 1000)
        slb1.Text = "MEM WR DWORD: " + geterrorstring(dwErr)
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim tmp_sdata As String
        Dim tmp_addr As UInteger
        Dim wSize As UInteger
        Dim tmp_data(1024) As Byte
        Dim dwErr As UInteger

        tmp_addr = "&H" + edwraddr.Text
        tmp_sdata = edwrblock.Text
        wSize = Len(tmp_sdata) / 2

        For i = 0 To wSize - 1
            tmp_data(i) = "&H" + tmp_sdata.Substring(0, 2)
            tmp_sdata = tmp_sdata.Remove(0, 2)
        Next

        dwErr = memwrblock(tmp_addr, tmp_data(0), wSize, 1000)
        slb1.Text = "MEM WR BLOCK: " + geterrorstring(dwErr)

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim tmp_addr As UInteger
        Dim tmp_byte As Byte
        Dim dwErr As UInteger

        tmp_addr = "&H" + edrdaddr.Text
        dwErr = memrd8bit(tmp_addr, tmp_byte, 1000)

        If dwErr = RET_OK Then
            RTBox.AppendText("READ BYTE: 0x" + Hex$(tmp_byte) & vbNewLine)
        End If
        slb1.Text = "MEM RD BYTE: " + geterrorstring(dwErr)
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim tmp_addr As UInteger
        Dim tmp_word As UShort
        Dim dwErr As UInteger

        tmp_addr = "&H" + edrdaddr.Text
        dwErr = memrd16bit(tmp_addr, tmp_word, 1000)

        If dwErr = RET_OK Then
            RTBox.AppendText("READ WORD: 0x" + Hex$(tmp_word) & vbNewLine)
        End If
        slb1.Text = "MEM RD WORD: " + geterrorstring(dwErr)
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim tmp_addr As UInteger
        Dim tmp_dword As UInteger
        Dim dwErr As UInteger

        tmp_addr = "&H" + edrdaddr.Text
        dwErr = memrd32bit(tmp_addr, tmp_dword, 1000)

        If dwErr = RET_OK Then
            RTBox.AppendText("READ DWORD: 0x" + Hex$(tmp_dword) & vbNewLine)

        End If
        slb1.Text = "MEM RD DWORD: " + geterrorstring(dwErr)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim wSize As UInteger
        Dim tmp_data(1024) As Byte
        Dim dwErr As UInteger
        Dim tmp_addr As UInteger
        Dim stri As String

        tmp_addr = "&H" + edrdaddr.Text

        wSize = nud1.Value
        dwErr = memrdblock(tmp_addr, tmp_data(0), wSize, 1000)

        If dwErr = RET_OK Then
            RTBox.AppendText(wSize.ToString + " Byte(s) read: ")

            If wSize > 0 Then
                stri = ""
                For i = 0 To wSize - 1
                    stri = stri + "[" + Hex$(tmp_data(i)) + "]"
                Next
                RTBox.AppendText(stri & vbNewLine)
            End If
        End If
        slb1.Text = "MEM RD BLOCK: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnSetMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetMode.Click
        Dim ucmode As Byte
        Dim ucslvaddr As Byte
        Dim dwErr As UInteger

        If RBMaster.Checked Then
            ucmode = 1
        ElseIf RBSlave.Checked Then
            ucmode = 2
        ElseIf RBProg.Checked Then
            ucmode = 3
        Else : ucmode = 0
        End If

        ucslvaddr = "&H" + EditConSlvAddr.Text
        ucslvaddr = ucslvaddr Or Convert.ToByte(CBGCSetMode.Checked)
        dwErr = setmode(ucmode, ucslvaddr, 1000)

        If dwErr = RET_OK Then
            If Convert.ToBoolean(ucslvaddr And 1) Then
                lbi2cslvadr.Text = "0x" + Hex$(ucslvaddr And &HFE) + " + GC"
            Else : lbi2cslvadr.Text = "0x" + Hex$(ucslvaddr And &HFE)
            End If

            EditI2CSlvAdr.Text = Hex$(ucslvaddr And &HFE)
            EditConSlvAddr.Text = Hex$(ucslvaddr And &HFE)
            CBGCSetMode.Checked = Convert.ToBoolean(ucslvaddr And &H1)
            CBSetAddrGC.Checked = Convert.ToBoolean(ucslvaddr And &H1)

            RBMaster.Checked = (ucmode = 1)
            RBSlave.Checked = (ucmode = 2)
            RBProg.Checked = (ucmode = 3)


            TabControl2.SelectedIndex = ucmode - 1
        End If
        slb1.Text = "SET MODE: " + geterrorstring(dwErr)
    End Sub

    Private Sub ClearMemoToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearMemoToolStripMenuItem.Click
        RTBox.Text = ""
    End Sub

    Private Sub BtnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnWrite.Click
        Dim wStatus As UInteger
        Dim wSize As UInteger
        Dim i As UInteger
        Dim si2cdata As String
        Dim i2cdata(1024) As Byte
        Dim dwErr As UInteger
        Dim ucSlv As UInteger

        ucSlv = "&H" + EditSlvAddr.Text
        si2cdata = EditWrite.Text
        wSize = Len(si2cdata) / 2

        For i = 0 To wSize - 1
            i2cdata(i) = "&H" + si2cdata.Substring(0, 2)
            si2cdata = si2cdata.Remove(0, 2)
        Next

        dwErr = writei2c(ucSlv, i2cdata(0), wSize, wStatus, 1000)

        If dwErr = RET_OK Then
            RTBox.AppendText(wSize.ToString + " BYTE(s) WRITTEN" & vbNewLine)

        End If
        slb1.Text = "WRITE I2C: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRead.Click
        Dim wStatus As UInteger
        Dim wSize As UInteger
        Dim stxt As String
        Dim buf(1024) As Byte
        Dim ucSlv As Byte
        Dim dwErr As UInteger
        Dim i As UInteger

        ucSlv = "&H" + EditSlvAddr.Text
        wSize = EditRCnt.Value
        EditRCnt.Value = wSize

        dwErr = readi2c(ucSlv, buf(0), wSize, wStatus, 1000)

        If dwErr = RET_OK Then
            RTBox.AppendText(wSize.ToString + "BYTE(s) READ: ")

            If wSize > 0 Then
                stxt = ""
                For i = 0 To wSize - 1
                    stxt = stxt + "[" + Hex$(buf(i)) + "] "
                Next
                RTBox.AppendText(stxt & vbNewLine)
            End If
        End If
        slb1.Text = "READ I2C: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnChkSlv_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnChkSlv.Click
        Dim ucSlvAddr As Byte
        Dim ucConnected As Byte
        Dim dwErr As UInteger

        ucSlvAddr = "&H" + EditSlvAddr.Text

        dwErr = chkslvaddr(ucSlvAddr, ucConnected, 1000)

        If dwErr = RET_OK Then
            If ucConnected = 1 Then
                LbChkSlv.Text = "OK"
            Else : LbChkSlv.Text = "BAD"
            End If

            EditSlvAddr.Text = Hex$(ucSlvAddr)
        End If

        slb1.Text = "CHECK SLAVE ADDR: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnScan.Click
        Dim dwErr As UInteger
        Dim buf(128) As Byte
        Dim ucSize As Byte
        Dim i As Byte
        Dim stxt As String

        dwErr = scani2c(buf(0), ucSize, 5000)

        If dwErr = RET_OK Then
            If ucSize > 0 Then
                RTBox.AppendText(ucSize.ToString + " DEVICES(s) FOUND: ")
                stxt = ""

                For i = 0 To ucSize - 1
                    stxt = stxt + "[" + Hex$(buf(i)) + "] "
                Next

                RTBox.AppendText(stxt & vbNewLine)
            Else : RTBox.AppendText("---NO DEVICES FOUND---" & vbNewLine)
            End If
        End If
        slb1.Text = "SCAN I2C: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnSetSCL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetSCL.Click
        Dim dwfreq As UInteger
        Dim dwErr As UInteger

        dwfreq = Convert.ToInt32(EditSCL.Text) * 1000
        dwErr = setscl(dwfreq, 1000)

        If dwErr = RET_OK Then
            Lbfreq.Text = (Math.Round(dwfreq / 1000)).ToString + " kHz"
        Else : Lbfreq.Text = "--- Hz"
        End If
        slb1.Text = "SET SCL: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnGetSCL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnGetSCL.Click
        Dim dwFreq As UInteger
        Dim dwErr As UInteger

        dwErr = getscl(dwFreq, 1000)

        If dwErr = RET_OK Then
            Lbfreq.Text = (Math.Round(dwFreq / 1000)).ToString + " kHz"
        Else : Lbfreq.Text = "--- kHz"
        End If
        slb1.Text = "GET SCL: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnSetIRQ_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetIRQ.Click
        Dim dwErr As UInteger
        Dim ucMode As Byte

        If RBirq0.Checked Then
            ucMode = 0
        ElseIf RBirq1.Checked Then
            ucMode = 1
        Else : ucMode = 2
        End If

        dwErr = resetirq(ucMode, 1000)

        If dwErr = RET_OK Then
            Select Case ucMode
                Case 0
                    RBirq0.Checked = True
                Case 1
                    RBirq1.Checked = True
                Case 2
                    RBirq2.Checked = True
                Case Else
                    RBirq0.Checked = True
            End Select
        End If
        slb1.Text = "ReSet IRQ: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnSetI2CSlvAdr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetI2CSlvAdr.Click
        Dim ucSlvAddr As Byte
        Dim dwErr As UInteger

        ucSlvAddr = "&H" + EditI2CSlvAdr.Text
        ucSlvAddr = ucSlvAddr Or Convert.ToByte(CBSetAddrGC.Checked)

        dwErr = seti2cslvaddr(ucSlvAddr, 1000)

        If dwErr = RET_OK Then
            If Convert.ToBoolean(ucSlvAddr And 1) Then
                lbi2cslvadr.Text = "0x" + Hex$(ucSlvAddr And &HFE) + " + GC"
            Else : lbi2cslvadr.Text = "0x" + Hex$(ucSlvAddr And &HFE)
            End If

            EditI2CSlvAdr.Text = Hex$(ucSlvAddr And &HFE)
            EditConSlvAddr.Text = Hex$(ucSlvAddr And &HFE)
            CBGCSetMode.Checked = Convert.ToBoolean(ucSlvAddr And &H1)
            CBSetAddrGC.Checked = Convert.ToBoolean(ucSlvAddr And &H1)
        End If
        slb1.Text = "SET SLAVE ADDR: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnWriteSlvBuf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnWriteSlvBuf.Click
        Dim ResEvent As String
        Dim wSize As UInteger
        Dim i As UInteger
        Dim si2cdata As String
        Dim i2cdata(2048) As Byte
        Dim dwErr As UInteger
        Dim ucEvent As Byte

        ucEvent = Convert.ToByte(CBIntOut.Checked)
        si2cdata = EditSlvBuf.Text
        wSize = Len(si2cdata) / 2
        ResEvent = ""

        Select Case ucEvent
            Case 0
                ResEvent = "WITHOUT EVENT"
            Case 1
                ResEvent = "WITH EVENT"
        End Select

        For i = 0 To wSize - 1
            i2cdata(i) = "&H" + si2cdata.Substring(0, 2)
            si2cdata = si2cdata.Remove(0, 2)
        Next

        dwErr = writei2cslavebuf(i2cdata(0), wSize, ucEvent, 1000)

        If dwErr = RET_OK Then
            RTBox.AppendText(wSize.ToString + " BYTE(s) WRITTEN TO SLAVE_BUF" & vbNewLine)
            RTBox.AppendText(ResEvent & vbNewLine)
        End If
        slb1.Text = "WRITE I2C: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnReInit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnReInit.Click
        Dim dwErr As UInteger

        dwErr = reinit(1000)
        slb1.Text = "REINIT...: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnLoadFactory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnLoadFactory.Click
        slb1.Text = "LOAD FACTORY SETTINGS...: " + geterrorstring(loadfactoryconfig(1000))
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Close()
    End Sub

    Private Sub Btn_TCPPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_TCPPort.Click
        Dim iPort As UInteger
        Dim dwErr As UInteger

        iPort = Convert.ToInt32(Edit_TCPPort.Text)
        Edit_TCPPort.Text = iPort.ToString
        dwErr = settcpport(iPort, 1000)
        slb1.Text = "SET TCP PORT: " + geterrorstring(dwErr)
    End Sub

    Private Sub Btn_UDPPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_UDPPort.Click
        Dim iPort As UInteger
        Dim dwErr As UInteger

        iPort = Convert.ToInt32(Edit_UDPPort.Text)
        Edit_UDPPort.Text = iPort.ToString
        dwErr = setudpport(iPort, 1000)
        slb1.Text = "SET UDP PORT: " + geterrorstring(dwErr)
    End Sub

    Public Function GetIPBytes(ByVal sIP As String, ByVal iPosi As Byte) As Byte
        Dim posi As Byte
        Dim SubIP As String
        Dim iIP As Byte

        SubIP = ""

        Select Case iPosi
            Case 1
                posi = 0
            Case 2
                posi = 4
            Case 3
                posi = 8
            Case 4
                posi = 12
            Case 5
                posi = 16
            Case 6
                posi = 20
            Case Else
                posi = 0
        End Select

        SubIP = sIP.Substring(posi, 3)
        SubIP = Trim(SubIP)
        If SubIP = "" Then
            SubIP = "0"
        End If

        iIP = Convert.ToInt32(SubIP)
        GetIPBytes = iIP
    End Function

    Private Sub BtnSetSGAR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetSGAR.Click
        Dim sTmp As String
        Dim dwErr As UInteger

        sTmp = ME_GAR.Text
        dwErr = setgar(GetIPBytes(sTmp, 1), GetIPBytes(sTmp, 2), GetIPBytes(sTmp, 3), GetIPBytes(sTmp, 4), 1000)
        slb1.Text = "SET GAR: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnSetSUBR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetSUBR.Click
        Dim sTmp As String
        Dim dwErr As UInteger

        sTmp = ME_SUBR.Text
        dwErr = setsubr(GetIPBytes(sTmp, 1), GetIPBytes(sTmp, 2), GetIPBytes(sTmp, 3), GetIPBytes(sTmp, 4), 1000)
        slb1.Text = "SET SUBR: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnSetSHAR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetSHAR.Click
        Dim sTmp As String
        Dim dwErr As UInteger

        sTmp = ME_SHAR.Text
        dwErr = setshar(GetIPBytes(sTmp, 1), GetIPBytes(sTmp, 2), GetIPBytes(sTmp, 3), GetIPBytes(sTmp, 4), GetIPBytes(sTmp, 5), GetIPBytes(sTmp, 6), 1000)
        slb1.Text = "SET SHAR: " + geterrorstring(dwErr)
    End Sub

    Private Sub BtnSIP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSIP.Click
        Dim sTmp As String
        Dim dwErr As UInteger

        sTmp = ME_IP.Text
        dwErr = setip(GetIPBytes(sTmp, 1), GetIPBytes(sTmp, 2), GetIPBytes(sTmp, 3), GetIPBytes(sTmp, 4), 1000)
        slb1.Text = "SET IP: " + geterrorstring(dwErr)
    End Sub

    Private Sub btnSaveSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveSettings.Click
        Dim dwErr As UInteger

        dwErr = savesettings(1000)
        slb1.Text = "SAVE SETTINGS...: " + geterrorstring(dwErr)
    End Sub

    Private Sub btnResetSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResetSettings.Click
        Dim dwErr As UInteger

        dwErr = resetsettings(1000)
        slb1.Text = "RESET SETTINGS...: " + geterrorstring(dwErr)
    End Sub
End Class